# Requires Borland Make utility

.autodepend # Header file dependencies

CC	= bcc32 -c
LINKER  = bcc32		
CFLAGS  = -DUSE_ASM

ASM	= bcc32 -Tm2 -c


# General rules
.cpp.obj:
	$(CC) $(CFLAGS) $<

.asm.obj:
	$(ASM) $<

# Default


help:
	@echo  Arageli by Nikolai Yu. Zolotykh
	@echo    version for Borland C++ 5.5 with asm code

# Executables

all:  testbg.exe testbig.exe testbio.exe testbr.exe sc.exe 

testbg.exe: testbg.obj bigarith.obj bigar32.obj
	$(LINKER) testbg.obj bigarith.obj bigar32.obj

testbig.exe: testbig.obj bigarith.obj bigar32.obj
	$(LINKER) testbig.obj bigarith.obj bigar32.obj

testbio.exe: testbio.obj bigarith.obj bigar32.obj
	$(LINKER) testbio.obj bigarith.obj bigar32.obj

testbr.exe: testbr.obj bigarith.obj bigar32.obj
	$(LINKER) testbr.obj bigarith.obj bigar32.obj

sc.exe: sc.obj bigarith.obj bigar32.obj
	$(LINKER) sc.obj bigarith.obj bigar32.obj


clean:
        @del bigar32.obj
        @del bigarith.obj
        @del testbg.obj
        @del testbg.tds
        @del testbig.obj
        @del testbig.tds
        @del testbio.obj
        @del testbio.tds 
        @del testbr.obj
        @del testbr.tds
        @del sc.obj
        @del sc.tds 

cleanall: clean
	@del testbg.exe
	@del testbig.exe
	@del testbio.exe
	@del testbr.exe
	@del sc.exe

new:      cleanall all


